package PersonLib;

import java.util.Comparator;

public class PersonComparator implements Comparator<Person> {

	private int column = 0;
	
	public PersonComparator() {
		this(0);
	}
	
	public PersonComparator(int column) {
		this.column = column;
	}
	
	@Override
	public int compare(Person p1, Person p2) {
		if (!(p1 instanceof Person) || !(p2 instanceof Person))
			return 0;
		switch(this.column) {
		case 0:
			return p1.getName().compareTo(p2.getName());
		case 1:
			return Integer.compare(p1.getAge(), p2.getAge());
		case 2:
			return Double.compare(p1.getWeight(), p2.getWeight());
		case 3:
			return Double.compare(p1.getHeight(), p2.getHeight());
		case 4:
			return p1.getGender().compareTo(p2.getGender());
		case 5:
			return p1.getActivity().compareTo(p2.getActivity());
		default:
			return 0;
		}
	}

}
