package PersonLib;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class PersonImporter {
	// load CSV
	public static List<Person> loadCSV(String filename) {
		List<Person> personList = new ArrayList<Person>();
		try (BufferedReader br = new BufferedReader(new FileReader(filename))) {
			System.out.println("file import: " + filename);

			String line = "";
			String delimiter = ",";

			while ((line = br.readLine()) != null) {
				// use comma as separator
				String[] items = line.split(delimiter);

				Person p = new Person();
				p.setName(items[0]);
				p.setAge(Integer.parseInt(items[1]));
				p.setWeight(Double.parseDouble(items[2]));
				p.setHeight(Double.parseDouble(items[3]));
				p.setGender(Gender.nameOf(items[4]));
				p.setActivity(Activity.nameOf(items[5]));
				System.out.println("Person: " + p);

				personList.add(p);
			}
		} catch (FileNotFoundException e) {
	e.printStackTrace();
	} catch (IOException e) {
	e.printStackTrace();
	}
	System.out.println("load successfully");
	return personList;
	}

	// save CSV
	public static void writeCSV(String path, List<Person> personList) {
		FileWriter fw;
		try {
			System.out.println("file save: " + path);

			fw = new FileWriter(path);
			for (Person p : personList) {
				System.out.println(p);
				fw.append(p.toString() + "\n");
			}
			fw.flush();
			fw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
