package PersonTableFrame;

import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import PersonLib.Activity;
import PersonLib.Gender;
import PersonLib.Person;

public class PersonDialog extends JDialog implements ActionListener, ItemListener, KeyListener {
	
	public final static int OK = 1;
	public final static int CANCEL = 2;
	int returnValue = 0;

	JLabel label1 = new JLabel("̸");
	JLabel label2 = new JLabel("");
	JLabel label3 = new JLabel("");
	JLabel label4 = new JLabel("Ű");
	JLabel label5 = new JLabel("");
	JLabel label6 = new JLabel("Ȱ");

	JTextField textfield1 = new JTextField(20);
	JTextField textfield2 = new JTextField(20);
	JTextField textfield3 = new JTextField(20);
	JTextField textfield4 = new JTextField(20);

	JRadioButton rbutton1 = new JRadioButton("FEMALE", true);
	JRadioButton rbutton2 = new JRadioButton("MALE");
	ButtonGroup rgroup1 = new ButtonGroup();
	JPanel panel1 = new JPanel();
	
	JComboBox<String> combobox1 = new JComboBox<String>(Activity.names());
	
	JButton button1 = new JButton("Ȯ");
	
	Activity selectedActivity;
	
	Person person = new Person();

	public PersonDialog() {
		setTitle("Person Dialog");
		setLayout(null); // no layout - absolute positioning
		
		label1.setBounds(20, 30, 100, 20);
		label2.setBounds(20, 60, 100, 20);
		label3.setBounds(20, 90, 100, 20);
		label4.setBounds(20, 120, 100, 20);
		label5.setBounds(20, 150, 100, 20);
		label6.setBounds(20, 180, 100, 20);
		this.add(label1);
		this.add(label2);
		this.add(label3);
		this.add(label4);
		this.add(label5);
		this.add(label6);
		
		textfield1.setBounds(120, 30, 150, 20);
		textfield2.setBounds(120, 60, 150, 20);
		textfield3.setBounds(120, 90, 150, 20);
		textfield4.setBounds(120, 120, 150, 20);
		this.add(textfield1);
		this.add(textfield2);
		this.add(textfield3);
		this.add(textfield4);
		textfield1.addKeyListener(this);
		
		panel1.add(rbutton1);
		panel1.add(rbutton2);
		rgroup1.add(rbutton1);
		rgroup1.add(rbutton2);
		panel1.setBounds(120, 150, 150, 30);
		this.add(panel1);
		
		combobox1.setBounds(120, 180, 150, 20);
		combobox1.addItemListener(this);
		this.add(combobox1);
		
		button1.setBounds(60, 220, 160, 20);
		button1.addActionListener(this);
		this.add(button1);
		
		setSize(300, 300);
		setModal(true); // set Modal (dialog)
	}

	public Gender selectGender() {
		if (rbutton1.isSelected())
			return Gender.FEMALE;
		else
			return Gender.MALE;
	}

	public Activity selectActivity() {
		return Activity.valueOf(combobox1.getSelectedIndex());
	}
	
	public void addPerson() {
		person.setName(textfield1.getText());
		person.setAge(Integer.parseInt(textfield2.getText()));
		person.setWeight(Double.parseDouble(textfield3.getText()));
		person.setHeight(Double.parseDouble(textfield4.getText()));
		person.setGender(selectGender());
		person.setActivity(selectActivity());
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		if ((JButton)e.getSource() == button1) {
			addPerson();
			returnValue = OK;
			dispose();
		}
	}

	@Override
	public void itemStateChanged(ItemEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
		int selectedIndex = cb.getSelectedIndex();
		switch(selectedIndex) {
		case 0:
			selectedActivity = Activity.LOW;
			break;
		case 1:
			selectedActivity = Activity.MEDIUM;
			break;
		case 2:
			selectedActivity = Activity.HIGH;
			break;
		default:
			break;
		}
	}

	@Override
	public void keyPressed(KeyEvent e) {
		int key = e.getKeyCode();
		if (key == KeyEvent.VK_ENTER) {
			Toolkit.getDefaultToolkit().beep();
			System.out.println("Enter pressed");

			addPerson();
			System.out.println("Person Dialog KeyPressed: " + person);
			returnValue = OK;
			dispose();
		}
	}

	@Override
	public void keyReleased(KeyEvent e) {
		
	}

	@Override
	public void keyTyped(KeyEvent e) {
		
	}
	
	public int getReturnValue()
	{
		return returnValue;
	}

	public Person getPerson()
	{
		return person;
	}

}
